VERSION 5.00
Begin VB.UserControl pwtFilePicker 
   Alignable       =   -1  'True
   Appearance      =   0  'Flat
   ClientHeight    =   2130
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3915
   EditAtDesignTime=   -1  'True
   KeyPreview      =   -1  'True
   ScaleHeight     =   2130
   ScaleWidth      =   3915
   Begin VB.CommandButton cmdSel 
      Caption         =   "&Invert"
      Height          =   315
      Index           =   1
      Left            =   2835
      TabIndex        =   3
      Top             =   225
      Width           =   720
   End
   Begin VB.CommandButton cmdSel 
      Caption         =   "&All"
      Height          =   315
      Index           =   0
      Left            =   2220
      TabIndex        =   2
      Top             =   195
      Width           =   510
   End
   Begin VB.PictureBox pbSplit 
      BorderStyle     =   0  'None
      Height          =   2115
      Left            =   1860
      MousePointer    =   9  'Size W E
      ScaleHeight     =   2115
      ScaleWidth      =   315
      TabIndex        =   5
      Top             =   90
      Width           =   315
   End
   Begin VB.DirListBox Dir 
      Height          =   765
      Left            =   210
      TabIndex        =   1
      Top             =   690
      Width           =   1710
   End
   Begin VB.DriveListBox Drive 
      Height          =   315
      Left            =   270
      TabIndex        =   0
      Top             =   255
      Width           =   1515
   End
   Begin VB.FileListBox File 
      Height          =   870
      Hidden          =   -1  'True
      Left            =   2220
      MultiSelect     =   2  'Extended
      System          =   -1  'True
      TabIndex        =   4
      Top             =   675
      Width           =   1650
   End
End
Attribute VB_Name = "pwtFilePicker"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'********************************
' FilePicker (C)1998 David Crowell
' You may use this source code within
' your own applications.  You may not
' distribute it on a website without my express
' permission.
'
' http://www.qtm.net/~davidc
' davidc@qtm.net
'
' This is a modified version for jStrip
'********************************

Private Const SPLITWIDTH As Long = 50                       ' Width of the split bar
Private Const HSPLITWIDTH As Long = SPLITWIDTH / 2  ' divide it by two


Private SplitPos As Single              ' ratio of first pane to total, 0 to 1 range
Private mNumFiles As Integer
Private mNumSelFiles As Integer
Private mPath As String
Private mSelFiles() As String
Private mEnabled As Boolean
Private mMask As String
Private DefaultPath As String

Public Event Change()

'
' Setting the Path property will automatically
' display that folder on the control.  If the
' path is invalid, it defaults to the application
' path
'
Public Property Let path(sPath As String)
    On Error GoTo er
    If Right(sPath, 1) <> "\" Then
        sPath = sPath & "\"
    End If
    mPath = sPath
    ChDrive mPath
    ChDir mPath
    RefreshFiles
Exit Property
er:
    NewPath
End Property

' Return the path
Public Property Get path() As String
Attribute path.VB_ProcData.VB_Invoke_Property = ";Behavior"
Attribute path.VB_MemberFlags = "400"
    If Right(mPath, 1) <> "\" Then      ' add the trailing "\" if necessary
        mPath = mPath + "\"
    End If
    path = mPath
End Property

' Return number of files in filelist
Public Property Get NumFiles() As Integer
Attribute NumFiles.VB_MemberFlags = "400"
    NumFiles = mNumFiles
End Property

' Return number of selected files in filelist
Public Property Get NumSelFiles() As Integer
Attribute NumSelFiles.VB_MemberFlags = "400"
    NumSelFiles = mNumSelFiles
End Property

' Return individual selected entries
Public Property Get SelFiles(Index As Integer) As String
Attribute SelFiles.VB_MemberFlags = "400"
    If Index < 1 Or Index > mNumSelFiles Then
        Err.Raise vbObjectError + 513, , "Index out of range."
        Exit Property
    End If
    SelFiles = mSelFiles(Index)
End Property

' Is it enabled?
Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Will the respond to the user?"
Attribute Enabled.VB_ProcData.VB_Invoke_Property = ";Behavior"
    Enabled = mEnabled
End Property

' enabled or disable the control
Public Property Let Enabled(val As Boolean)
    mEnabled = val
    Dir.Enabled = mEnabled
    Drive.Enabled = mEnabled
    File.Enabled = mEnabled
    cmdSel(0).Enabled = mEnabled
    cmdSel(1).Enabled = mEnabled
    PropertyChanged "Enabled"
End Property

' get the filemask
Public Property Get Mask() As String
Attribute Mask.VB_Description = "Filemask to decide what files to display"
Attribute Mask.VB_ProcData.VB_Invoke_Property = ";Behavior"
    Mask = mMask
End Property

' set the filemask
Public Property Let Mask(val As String)
    mMask = val
    File.Pattern = mMask
    RefreshFiles
    PropertyChanged "Mask"
End Property

' get the position of the splitbar
Public Property Get SplitPercentage() As Byte
Attribute SplitPercentage.VB_Description = "Percentage of width for the left pane.  Range 20-80."
Attribute SplitPercentage.VB_ProcData.VB_Invoke_Property = ";Appearance"
    SplitPercentage = SplitPos * 100
End Property

' set the position of the splitbar
Public Property Let SplitPercentage(val As Byte)
    SplitPos = val / 100
    UserControl_Resize
    PropertyChanged "SplitPercentage"
End Property

'
' Pressing the spacebar or the enter key with
' the dir list box in focus will select that folder
'
Private Sub Dir_KeyPress(KeyAscii As Integer)
    If KeyAscii = 13 Or KeyAscii = 32 Then
        If Dir.path <> Dir.List(Dir.ListIndex) Then
            Dir.path = Dir.List(Dir.ListIndex)
        End If
    End If
End Sub

'
' Make sure the bar is visible when clicked.
'
Private Sub pbSplit_MouseDown(Button As Integer, Shift As Integer, x As Single, Y As Single)
    pbSplit.ZOrder
    pbSplit.BackColor = vbButtonText
End Sub

'
' Move the Bar
'
Private Sub pbSplit_MouseMove(Button As Integer, Shift As Integer, x As Single, Y As Single)
    If Button = vbLeftButton Then
        pbSplit.Move pbSplit.Left + (x - HSPLITWIDTH)
    End If
End Sub

'
' When mouse button is released, update the panes
'
Private Sub pbSplit_MouseUp(Button As Integer, Shift As Integer, x As Single, Y As Single)
    SplitPos = (pbSplit.Left + HSPLITWIDTH) / UserControl.Width
    pbSplit.BackColor = UserControl.BackColor
    UserControl_Resize
End Sub

'
' Set the defaults
'
Private Sub UserControl_InitProperties()
    SplitPercentage = 40
    path = App.path
    Enabled = True
    Mask = "*.*"
    RefreshFiles
End Sub

Private Sub usercontrol_initialize()
    DefaultPath = App.path
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    Enabled = PropBag.ReadProperty("Enabled", True)
    Mask = PropBag.ReadProperty("Mask", "*.*")
    SplitPercentage = PropBag.ReadProperty("SplitPercentage", 40)
End Sub
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "Enabled", Enabled, True
    PropBag.WriteProperty "Mask", Mask, "*.*"
    PropBag.WriteProperty "SplitPercentage", SplitPercentage, 40
End Sub


Private Sub UserControl_KeyPress(KeyAscii As Integer)
    If KeyAscii = 1 Then        ' Allow ctrl-A to select all
        cmdSel_Click 0
    End If
    If KeyAscii = 9 Then          ' ctrl-I to invert selection
        cmdSel_Click 1
    End If
End Sub

'
' This is the meat of the resizing,
' whether from the control being resized, or
' the splitter adjusted.
'
Private Sub UserControl_Resize()

    On Error Resume Next        ' we don't want any runtime errors

    Dim ControlWidth As Long    ' I store many properties in variables
    Dim ControlHeight As Long   ' for better performance
    Dim lpwidth As Long
    Dim rpleft As Long
    Dim rpwidth As Long
    Dim bw As Long
    Dim diff As Long
    
    ControlWidth = UserControl.Width
    ControlHeight = UserControl.Height
        
    ' I have minimums here, but they do not actually change
    ' the size of the control, they fudge the numbers to
    ' prevent errors.
    If ControlHeight < 400 Then ControlHeight = 400
    If ControlWidth < 200 Then ControlWidth = 200
    
    ' I have an allowable range for the first pane width
    ' to be from 20% to 80% of the total control width.
    If SplitPos < 0.2 Then SplitPos = 0.2
    If SplitPos > 0.8 Then SplitPos = 0.8
    
    lpwidth = (ControlWidth * SplitPos) - (SPLITWIDTH + 2)
    rpwidth = (ControlWidth * (1 - SplitPos)) - (SPLITWIDTH + 2)
    rpleft = (ControlWidth * SplitPos) + (SPLITWIDTH + 2)
    bw = rpwidth / 2
    
    pbSplit.Move (ControlWidth * SplitPos) - HSPLITWIDTH, 0, SPLITWIDTH, ControlHeight
    Drive.Move 0, 0, lpwidth
    Dir.Move 0, Drive.Height + 2, lpwidth, ControlHeight - (Drive.Height + 2)
    File.Move rpleft, Dir.Top, rpwidth, Dir.Height
    cmdSel(0).Move rpleft, 0, bw - 20, Drive.Height
    cmdSel(1).Move rpleft + bw, 0, bw - 20, Drive.Height
    
    diff = (Dir.Top + Dir.Height) - (File.Top + File.Height)
    File.Move rpleft, Dir.Top + diff
        
End Sub

'
' Update current directory when
' user double-clicks in the directory
' list box.
'
Private Sub Dir_Change()
    On Error GoTo er
    ChDir Dir.path
    RefreshFiles
Exit Sub
er:
    NewPath
End Sub

'
' Update current directory when
' user changed drives.
'
Private Sub Drive_Change()
    On Error GoTo er
    ChDrive Drive.Drive
    RefreshFiles
Exit Sub
er:
    NewPath
End Sub

'
' Update all three controls, and
' count total, and selected files.
'
Private Sub RefreshFiles()
On Error GoTo er
    File.Pattern = mMask
    mPath = CurDir
    Drive.Drive = mPath
    Dir.path = mPath
    File.path = mPath
    CountFiles
Exit Sub
er:
    NewPath
    Resume
End Sub

'
' Recount selected files when user
' clicks in the file list box
'
Private Sub File_Click()
    CountFiles
End Sub

'
' Store the number of total files, and
' selected files.
'
Private Sub CountFiles()

If mEnabled Then
    Dim iSelected As Integer
    Dim iCount As Integer
    mNumFiles = File.ListCount
    If mNumFiles > 0 Then
        ReDim mSelFiles(mNumFiles)
    End If
    For iCount = 0 To mNumFiles - 1
        If File.Selected(iCount) = True Then
            iSelected = iSelected + 1
            mSelFiles(iSelected) = File.List(iCount)
        End If
    Next iCount
    mNumSelFiles = iSelected
    ReDim Preserve mSelFiles(mNumSelFiles)
    RaiseEvent Change
End If
End Sub

'
' If user selects a bad path or
' empty floppy drive, this routine
' will change the path back to
' c:\
'
Private Sub NewPath()
    mPath = DefaultPath
    ChDir mPath
    ChDrive mPath
    RefreshFiles
End Sub

'
' Select all the files, or invert selection
'
Private Sub cmdSel_Click(Index As Integer)

    Dim ti As Integer
    ti = File.TopIndex

    Me.Enabled = False
    File.Visible = False

    Dim i As Integer
    Dim num As Integer
    num = File.ListCount
    If Index = 1 Then                      ' invert selection
        For i = 0 To num - 1
            File.Selected(i) = Not File.Selected(i)
        Next i
    Else                                            ' select all
        For i = 0 To num - 1
            File.Selected(i) = True
        Next i
    End If
    File.Visible = True
    Me.Enabled = True
    File.TopIndex = ti
    CountFiles
    
End Sub

